#ifndef __VPCALC_CORE_H
#define __VPCALC_CORE_H

typedef void *core_o;

#define _cycle(core, cnt) { core->cycles -= cnt; }

core_o core_new(mem_o mem, dev_o dev, timing_o *rate);
void core_del(core_o core);

int core_execute(core_o core);
void core_terminate(core_o core);

int core_cycle(core_o core);
void core_interrupt(core_o core, unsigned int data);

void core_call(core_o core, unsigned int addr);
void core_ret(core_o core);

void core_report(core_o core, FILE *out);
void core_alter(core_o core, const char *regname, unsigned int value);
int core_unassemble(core_o core, unsigned int loc, FILE *out);

#endif 
